/******************************* Copyright notice *******************************
Copyright (C)2002 by Andrei Loskutov <loskutov@gmx.de>. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
********************************************************************************/


/**
 * Created on 02.12.2002
 *
 * To change this generated comment edit the template variable "filecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of file comments go to
 * Window>Preferences>Java>Code Generation.
 */
package adiag.gui;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.GraphicsConfiguration;
import java.awt.Image;
import java.awt.Paint;
import java.awt.Polygon;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.Stroke;
import java.awt.RenderingHints.Key;
import java.awt.font.FontRenderContext;
import java.awt.font.GlyphVector;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.image.BufferedImageOp;
import java.awt.image.ImageObserver;
import java.awt.image.RenderedImage;
import java.awt.image.renderable.RenderableImage;
import java.text.AttributedCharacterIterator;
import java.util.Map;
/**
 * @author Andy the Great
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public interface BVGraphics {
    void draw(Shape s);
    boolean drawImage(Image img, AffineTransform xform, ImageObserver obs);
    void drawImage(BufferedImage img, BufferedImageOp op, int x, int y);
    void drawRenderedImage(RenderedImage img, AffineTransform xform);
    void drawRenderableImage(RenderableImage img, AffineTransform xform);
    void drawString(String str, int x, int y);
    void drawString(String s, float x, float y);
    void drawString(AttributedCharacterIterator iterator, int x, int y);
    void drawString(AttributedCharacterIterator iterator, float x, float y);
    void drawGlyphVector(GlyphVector g, float x, float y);
    void fill(Shape s);
    boolean hit(Rectangle rect, Shape s, boolean onStroke);
    GraphicsConfiguration getDeviceConfiguration();
    void setComposite(Composite comp);
    void setPaint(Paint paint);
    void setStroke(Stroke s);
    void setRenderingHint(Key hintKey, Object hintValue);
    Object getRenderingHint(Key hintKey);
    void setRenderingHints(Map hints);
    void addRenderingHints(Map hints);
    RenderingHints getRenderingHints();
    void translate(int x, int y);
    void translate(double tx, double ty);
    void rotate(double theta);
    void rotate(double theta, double x, double y);
    void scale(double sx, double sy);
    void shear(double shx, double shy);
    void transform(AffineTransform Tx);
    void setTransform(AffineTransform Tx);
    AffineTransform getTransform();
    Paint getPaint();
    Composite getComposite();
    void setBackground(Color color);
    Color getBackground();
    Stroke getStroke();
    void clip(Shape s);
    FontRenderContext getFontRenderContext();
    Graphics create();
    Color getColor();
    void setColor(Color c);
    void setPaintMode();
    void setXORMode(Color c1);
    Font getFont();
    void setFont(Font font);
    FontMetrics getFontMetrics(Font f);
    Rectangle getClipBounds();
    void clipRect(int x, int y, int width, int height);
    void setClip(int x, int y, int width, int height);
    Shape getClip();
    void setClip(Shape clip);
    void copyArea(int x, int y, int width, int height, int dx, int dy);
    void drawLine(int x1, int y1, int x2, int y2);
    void fillRect(int x, int y, int width, int height);
    void clearRect(int x, int y, int width, int height);
    void drawRoundRect(
        int x,
        int y,
        int width,
        int height,
        int arcWidth,
        int arcHeight);
    void fillRoundRect(
        int x,
        int y,
        int width,
        int height,
        int arcWidth,
        int arcHeight);
    void drawOval(int x, int y, int width, int height);
    void fillOval(int x, int y, int width, int height);
    void drawArc(
        int x,
        int y,
        int width,
        int height,
        int startAngle,
        int arcAngle);
    void fillArc(
        int x,
        int y,
        int width,
        int height,
        int startAngle,
        int arcAngle);
    void drawPolyline(int[] xPoints, int[] yPoints, int nPoints);
    void drawPolygon(int[] xPoints, int[] yPoints, int nPoints);
    void fillPolygon(int[] xPoints, int[] yPoints, int nPoints);
    boolean drawImage(Image img, int x, int y, ImageObserver observer);
    boolean drawImage(
        Image img,
        int x,
        int y,
        int width,
        int height,
        ImageObserver observer);
    boolean drawImage(
        Image img,
        int x,
        int y,
        Color bgcolor,
        ImageObserver observer);
    boolean drawImage(
        Image img,
        int x,
        int y,
        int width,
        int height,
        Color bgcolor,
        ImageObserver observer);
    boolean drawImage(
        Image img,
        int dx1,
        int dy1,
        int dx2,
        int dy2,
        int sx1,
        int sy1,
        int sx2,
        int sy2,
        ImageObserver observer);
    boolean drawImage(
        Image img,
        int dx1,
        int dy1,
        int dx2,
        int dy2,
        int sx1,
        int sy1,
        int sx2,
        int sy2,
        Color bgcolor,
        ImageObserver observer);
    void dispose();
    Graphics create(int x, int y, int width, int height);
    void drawBytes(byte[] data, int offset, int length, int x, int y);
    void drawChars(char[] data, int offset, int length, int x, int y);
    void drawPolygon(Polygon p);
    void drawRect(int x, int y, int width, int height);
    void fillPolygon(Polygon p);
    Rectangle getClipBounds(Rectangle r);
    Rectangle getClipRect();
    FontMetrics getFontMetrics();
    boolean hitClip(int x, int y, int width, int height);
    String toString();
}